-----------------------------------------------------------------------------------------------
-- Client Lua Script for HideActionBarShadow
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- HideActionBarShadow Module Definition
-----------------------------------------------------------------------------------------------
local HideActionBarShadow = {} 
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function HideActionBarShadow:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    return o
end

function HideActionBarShadow:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- HideActionBarShadow OnLoad
-----------------------------------------------------------------------------------------------
function HideActionBarShadow:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("HideActionBarShadow.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
	
end

-----------------------------------------------------------------------------------------------
-- HideActionBarShadow OnDocLoaded
-----------------------------------------------------------------------------------------------
function HideActionBarShadow:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
		Apollo.RegisterSlashCommand("habs", "OnHABSOn", self)
		if self.tSettings == nil then
			self.tSettings = {}
			self.tSettings.hideShadow = true
		end
		if self.tSettings.hideShadow then
			self:Hide()
		end
	end
end

-- on SlashCommand "/habs"
function HideActionBarShadow:OnHABSOn()
	bars = Apollo.FindWindowByName("BarShadowLeft"):IsShown()

	if  bars then
		Print("Hiding Ability Bar Shadow")
		self:Hide()
	else 
		Print("Showing Ability Bar Shadow")
		self:Show()
	end
end

function HideActionBarShadow:Hide()
	self.tSettings.hideShadow= true
	Apollo.FindWindowByName("BarShadow"):Show(false)
	Apollo.FindWindowByName("BarShadowLeft"):Show(false)
	Apollo.FindWindowByName("BarShadowRight"):Show(false)		
end

function HideActionBarShadow:Show()
	self.tSettings.hideShadow= false
	Apollo.FindWindowByName("BarShadow"):Show(true)
	Apollo.FindWindowByName("BarShadowLeft"):Show(true)
	Apollo.FindWindowByName("BarShadowRight"):Show(true)		
end

-----------------------------------------------------------------------------------------------
-- HideActionBarShadow Instance
-----------------------------------------------------------------------------------------------
local HideActionBarShadowInst = HideActionBarShadow:new()
HideActionBarShadowInst:Init()


function HideActionBarShadow:OnRestore(eLevel, table)
	if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Account then return end
		self.tSettings = {}
		self.tSettings.hideShadow = true
	for k,v in pairs(table) do
    	self.tSettings[k]=v
	end
	
	
end

function HideActionBarShadow:OnSave(eLevel)
	if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Account then return end
		local tsave= {}
		tsave.hideShadow = self.tSettings.hideShadow
	return tsave
end